//---------------------------------------------------------------------------

#ifndef _MD5H
#define _MD5H
//---------------------------------------------------------------------------
#include <vcl.h>

typedef struct {
  unsigned int state[4];        /* state (ABCD) */
  unsigned int count[2];        /* number of bits, modulo 2^64 (lsb first) */
  unsigned char buffer[64];     /* input buffer */
} MD5_CTX;

class MD5Coder
{
private:
        static unsigned char PADDING[64];

        static void MD5Init(MD5_CTX * context);
        static void MD5Update(MD5_CTX * context, unsigned char * input, unsigned int inputLen);
        static void MD5Final(unsigned char digest[16], MD5_CTX * context);
        static void MD5Transform(unsigned int state[4], unsigned char block[64]);
        static void Encode(unsigned char *output,unsigned int *input,unsigned int len);
        static void Decode(unsigned int * output, unsigned char * input, unsigned int len);

protected:
public:
        static AnsiString MD5String(char *in);
        static AnsiString MD5File(AnsiString filename);
        static void MD5Buff(char *in,int length,char *out);//outΪchar[16]
};
#endif
