//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <DBCtrls.hpp>
#include <DBGrids.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Grids.hpp>
#include <Menus.hpp>
#include <ADODB.hpp>
#include <DB.hpp>
#include "CSPIN.h"
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
#include <jpeg.hpp>
#include <FileCtrl.hpp>
//---------------------------------------------------------------------------
class TMainBox : public TForm
{
__published:	// IDE-managed Components
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet2;
        TPanel *Panel6;
        TMainMenu *MainMenu1;
        TMenuItem *N1;
        TMenuItem *x1;
        TStatusBar *StatusBar1;
        TPanel *Panel7;
        TLabel *LabelTitle;
        TADOConnection *ADOConnMain;
        TADOQuery *ADOQueryMain;
        TDataSource *DataSourceMain;
        TDBGrid *DBGrid1;
        TPanel *Panel5;
        TPanel *PanelTools;
        TPanel *Panel2;
        TPanel *PanelBitDB;
        TPanel *PanelDoc;
        TPanel *PanelPic;
        TPanel *Panel10;
        TBevel *BevelFileName;
        TImage *ImgOther;
        TImage *ImgXLS;
        TImage *ImgDoc;
        TImage *ImgPDF;
        TPanel *Panel11;
        TSpeedButton *SpeedButton1;
        TSpeedButton *SpeedButton2;
        TPanel *PnlFileName;
        TOpenDialog *OpenDialog1;
        TSaveDialog *SaveDialog1;
        TImage *ImageBg;
        TPanel *PanelTool2;
        TBevel *Bevel8;
        TPopupMenu *PopupMenu1;
        TMenuItem *N2;
        TMenuItem *E1;
        TMenuItem *N3;
        TMenuItem *V1;
        TOpenPictureDialog *OpenPictureDialog1;
        TSavePictureDialog *SavePictureDialog1;
        TImage *ImagePic;
        TPanel *PanelPage;
        TSpeedButton *PageUp;
        TSpeedButton *PageDown;
        TPanel *PanelSearch;
        TSpeedButton *SpeedButton6;
        TEdit *EKey;
        TComboBox *Com12;
        TComboBox *Com11;
        TBevel *Bevel2;
        TBevel *Bevel6;
        TMenuItem *N4;
        TMenuItem *CSV1;
        TMenuItem *D1;
        TMenuItem *N5;
        TMenuItem *N6;
        TMenuItem *A1;
        TMenuItem *H1;
        TMenuItem *C1;
        TMenuItem *A2;
        TMenuItem *N7;
        TMenuItem *N8;
        TMenuItem *U1;
        TTabSheet *TabSheet3;
        TDBGrid *DBGrid2;
        TPanel *PanelUser;
        TSpeedButton *SpeedButton4;
        TSpeedButton *SpeedButton5;
        TSpeedButton *SpeedButton11;
        TSpeedButton *ShowAllUser;
        TBevel *Bevel7;
        TBevel *Bevel9;
        TBevel *Bevel10;
        TADOQuery *ADOQueryUser;
        TDataSource *DataSourceUser;
        TPanel *Panel1;
        TPanel *Panel3;
        TBevel *Bevel4;
        TSpeedButton *SpeedButton8;
        TBevel *Bevel5;
        TSpeedButton *SpeedButton10;
        TSpeedButton *SpeedButton9;
        TBevel *Bevel1;
        TSpeedButton *SpeedButton7;
        TSpeedButton *SpeedButton3;
        TBevel *Bevel3;
        void __fastcall SpeedButton8Click(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall SpeedButton3Click(TObject *Sender);
        void __fastcall DataSourceMainDataChange(TObject *Sender,
          TField *Field);
        void __fastcall SpeedButton1Click(TObject *Sender);
        void __fastcall SpeedButton2Click(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall SpeedButton7Click(TObject *Sender);
        void __fastcall N2Click(TObject *Sender);
        void __fastcall E1Click(TObject *Sender);
        void __fastcall V1Click(TObject *Sender);
        void __fastcall ImgPDFDblClick(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall Com11Change(TObject *Sender);
        void __fastcall SpeedButton6Click(TObject *Sender);
        void __fastcall EKeyKeyPress(TObject *Sender, char &Key);
        void __fastcall PageUpClick(TObject *Sender);
        void __fastcall PageDownClick(TObject *Sender);
        void __fastcall A1Click(TObject *Sender);
        void __fastcall N5Click(TObject *Sender);
        void __fastcall U1Click(TObject *Sender);
        void __fastcall SpeedButton4Click(TObject *Sender);
        void __fastcall SpeedButton11Click(TObject *Sender);
        void __fastcall SpeedButton5Click(TObject *Sender);
        void __fastcall ShowAllUserClick(TObject *Sender);
        void __fastcall SpeedButton9Click(TObject *Sender);
        void __fastcall TabSheet1Resize(TObject *Sender);
        void __fastcall CSV1Click(TObject *Sender);
        void __fastcall SpeedButton10Click(TObject *Sender);
        void __fastcall DBGrid1TitleClick(TColumn *Column);
private:	// User declarations
public:		// User declarations
        __fastcall TMainBox(TComponent* Owner);
        void __fastcall TMainBox::TabView(int i);
        void __fastcall TMainBox::FileView(String fname);
        void __fastcall TMainBox::picView();
        String     __fastcall   TMainBox::JiaMi(String   SourceStr);
        String     __fastcall   TMainBox::JieMi(String   SourceStr);
        int        __fastcall   TMainBox::reCount(String str);

};
//---------------------------------------------------------------------------
extern PACKAGE TMainBox *MainBox;
//---------------------------------------------------------------------------
#endif
